package at.jku.ssw.pi.sort.impl;

import java.util.Comparator;

import at.jku.ssw.pi.sort.Sorter;

/**
 * A simple sorting algorithm that works by repeatedly stepping through the list
 * to be sorted, comparing each pair of adjacent items and swapping them if they
 * are in the wrong order.
 */
@SuppressWarnings({ "rawtypes", "unchecked" })
public class BubbleSort extends Sorter {

	/** Sorts the array <code>data</code> of comparable objects. */
	public Object[] sort(Object[] data, Comparator cmp) {
		boolean swapped;
		do {
			swapped = false;
			for (int i = 0; i < data.length - 1; i++) {
				if (cmp.compare(data[i], data[i + 1]) > 0) {
					swap(data, i, i + 1);
					swapped = true;
				}
			}
		} while (swapped);
		return data;
	}

	private void swap(Object[] data, int index1, int index2) {
		Object dummy = data[index1];
		data[index1] = data[index2];
		data[index2] = dummy;
	}
}