package at.jku.ssw.pi.sort.impl;

import java.util.Comparator;

import at.jku.ssw.pi.sort.Sorter;

/** A in-place comparison sort algorithm. */
@SuppressWarnings({ "rawtypes", "unchecked" })
public class SelectionSort extends Sorter {
	/** Sorts the array <code>items</code> of comparable objects. */
	public Object[] sort(Object[] data, Comparator cmp) {
		for (int sorted = 0; sorted < data.length - 1; sorted++) {
			int min = sorted;
			Object val = data[min];
			for (int i = sorted + 1; i < data.length; i++) {
				if (cmp.compare(data[i], val) < 0) {
					min = i;
					val = data[min];
				}
			}
			if (sorted != min)
				swap(data, sorted, min);
		}
		return data;
	}

	private static void swap(Object[] data, int index1, int index2) {
		Object dummy = data[index1];
		data[index1] = data[index2];
		data[index2] = dummy;
	}
}